;CONV modif del 15 01 2004
;stage, setup piu info in finale 

(defun C:CONV ()

(setq DTR (/ PI 180))		;fattore di moltiplicazione x gradi verso radianti  pi  Pi greco!
(setq DESTRA (* 0 DTR))		;traduzione del comando polar  
(setq SINISTRA (* 180 DTR))	;traduzione del comando polar 
(setq SU (* 90 DTR))		;traduzione del comando polar 
(setq GIU (* 270 DTR))		;traduzione del comando polar 
(setq DIAG (* 45 DTR))		;traduzione del comando polar x 45 gradi 

(SETQ OSN (GETVAR "OSMODE"))						;salva gli snap  

(SETVAR "OSMODE" 3)							;salva gli snap  

  (setq Z1 (getpoint "\nSeleziona ZONA angolo in basso a sinistra"))
  (command "_ucs" "o" Z1)						;mette l'origine in z1
  (setq Z1 (list 0 0 ))	
  (setq Z2 (getpoint "\nSeleziona ZONA angolo alto destra "))		;trova il punto z2
  (setvar "osmode" 0)							;toglie lo snap 

  (setq xZ1(car Z1))
  (setq yZ1(cadr Z1))
  (setq xz2 (car z2))
  (setq yz2(cadr z2))
  (setq asseX(/ xz2 2))							;coordinata del centro asse X dello spazio
  (Setq Z11 (list xz2 yz1))
  (setq distzona (distance Z1 Z11))					;distanza massima senza corridoi

	(setq Bstage (getdist "\nDistanza BACK STAGE\n"))		;spazio dal fondo 
        (setq YCBstage (- Yz2 Bstage ))					;centro back stage
        (setq P0 (list assex YCBstage))					;punto inserzione stage

        (setq SM  (getdist "\nDistanza laterale dai muri\n"))		;distanza dai muri laterali 
	(setq DB (getdist "\nDistanza da fondo sala\n"))			;distanza dal fondo sala 
      
  	
	(initget 1 "Yes No")
  	(setq STAGE (getkword "\nStage? Yes No\n"))			;determina se voglio una scena 

 (cond
   	((= STAGE "Yes")

	 

	 (if (not (tblsearch "LAYER" "!STAGE"))
  (progn
   (setq regen (getvar "REGENMODE"))
   (setvar "REGENMODE" 0)
   (command "_layer" "_m" "!STAGE")
   (command "_c" "5" "!STAGE")		;colore Blu
   (command "")
   (setvar "REGENMODE" regen)
  )
 )

 ; rende attivo il layer !STAGE

 (command "_layer" "_s" "!STAGE" "")
 (command "_color" "BYLAYER")
	 

	(setq LUNG (getdist "\nLUNG STAGE X?\n"));	dimensioni utilizzatore stage
        (setq ALT  (getdist "\nHAUT STAGE Y?\n"));	dimensioni utilizzatore stage


	(initget 1 "Carre Pingpong Stageright Dance")
  	(setq Tstage (getkword "\ntype Carr Pingpong Stageright Dancefloor?\n"))	;determina il tipo di stage scelto 


	 (cond 
   			((= Tstage "Carre")
	
  			(setq As (POLAR P0 SINISTRA (/ LUNG 2.0))) 
			(setq Bs (POLAR As GIU ALT))
			(setq Cs (POLAR Bs DESTRA LUNG))
			(setq Ds (POLAR Cs SU ALT ))      
			(command "_pline" As Bs Cs Ds "c" )				;disegna la polilinea stage centrata nello spazio

		 	(setq P0 (list assex YCBstage))					;rimette P0  iniziale al centro del back stage!
		 	(setq FFstage (* eslin LINEE))					;altezza stage installato
			(setq CFstage (POLAR P0 GIU FFstage))				;centro Front stage

			(setq AREA_STAGE  (rtos(* LUNG ALT))) 
			(setq message_stage (strcat  "STAGE " (rtos LUNG)  " x " (rtos ALT)  " surface SqM " AREA_STAGE ))
			;(alert message_stage)

		 
        	
    		);fine COND Carr

 			((= Tstage "Pingpong"); fatto 

			(setq Bloc 2.44) 									;ingombro blocco intero 
			(setq Mibloc (/ Bloc 2.0))										
  			(setq Blocco "ping_pong")								;nome del blocco

    			(setq A (fix(/ LUNG 2.44 )))	;colonne possibili con rot 0 
			(setq B (fix(/ LUNG 1.83)))	;colonne possibili con rot 90 
			(setq C (fix(/ ALT 2.44)))	;linee possibili con rot 0 
			(setq D (fix(/ ALT 1.83)))	;linee possibili con rot 90 

		   (if(= A 0)(setq A 1)
	  		(setq A A)
	  		)
			(if(= B 0)
	  		(setq B 1)
	  		(setq B B)
	  		)
			(if(= C 0)
	  		(setq C 1)
		  	(setq C C)
		  	)
			(if(= D 0)
	  		(setq D 1)
	  		(setq D D)
	  	    )
								;------STAGE 1---blocchi  ruotati   0 gradi -----------------------
    	
	    	(setq LUNGHEZZA1 (* A 2.44))
	    	(setq ALTEZZA1 (* D 1.83))
	    	(setq INFO_STAGE1 (* ALTEZZA1 LUNGHEZZA1))

    								;------STAGE 2---blocchi  ruotati   90 gradi -----------------------
    	
    	    	(setq LUNGHEZZA2 (* B 1.83))
   	    	(setq ALTEZZA2 (* C 2.44))
    	    	(setq INFO_STAGE2 (* ALTEZZA2 LUNGHEZZA2))

    								;creazione stringhe messaggio per scelta stage---------
		(setq tLung1 (rtos LUNGHEZZA1 2 2))
		(setq tLung2 (rtos LUNGHEZZA2 2 2))
		(setq tAlt1 (rtos ALTEZZA1 2 2))
		(setq tAlt2 (rtos ALTEZZA2 2 2))
		(setq tinfo1 (rtos INFO_STAGE1 2 2))
		(setq tinfo2 (rtos INFO_STAGE2 2 2))

	

 
	(setq message_stage1 (strcat "stage1 mt " tlung1 " x " talt1  " Sqm " tinfo1 
	" oppure stage2 mt "  tlung2  " x "  talt2   " Sqm " tinfo2 " 1 o 2\n"))

	(initget 1 "stage1 stage2")
	(setq Rot_STAGE (getkword message_stage1))	;determina il tipo di stage scelto 
 

		(if
		     (= Rot_STAGE  "stage1")
  	 	     (setq rot_bloc 0)
    	 	     (setq rot_bloc 90)
   		 )						;determina se il blocco va ruotato di 90 gradi o no e ordina i valori trovati  

    		(Cond   ;cond rotazione blocco
		  	((= rot_bloc 0)
  			(setq EsCOL 2.44)			;spazio tra colonne
			(setq EsLIN 1.83)			;spazio tra linee
			(setq LINEE D)				;quante linee
			(setq COLONNE A)			;quante colonne

			 			(if
						  (and
						    (= COLONNE 1)
						    (= LINEE 1)
						   );fine and
					   		(progn
						  (setq TIPO Alfa)
						  (setq sposta (/ escol 2.0))
						  (setq P0 (polar P0 DESTRA sposta))

						  (setq sposta ESLIN)
						  (setq P0 (polar P0 GIU sposta))

						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  
					  		);fine progn
					  	);fine if A

					  (if
						  (and
						    (= COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Beta)
					  	  (setq sposta (/ escol 2.0))
						  (setq P0 (polar P0 DESTRA sposta))
						  (setq sposta (* eslin linee ))
						  (setq P0 (polar P0 GIU sposta))
						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					    );fine if B

					(if
						  (and
						    (> COLONNE 1)
						    (= LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Gamma)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta 	EsLIN)
						  (setq P0 (polar P0 GIU sposta))
						  
						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsCOL  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					   );fine if C

					 (if
					    (and
						 (> COLONNE 1)
						 (> LINEE 1)
					     );fine and
						(progn
						  (setq TIPO Delta)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0 )1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta (* eslin linee ))
						  (setq P0 (polar P0 GIU sposta))
						  
					  	  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN EsCOL "" )	;creaa l'array dei blocchi stage 
	
					 	)	;fin progn
					  )		;fine if D

			 
		    	);fine blocco non ruotato
			 
			((= rot_bloc 90)	;inizio blocco ruotato 
  		 	(setq EsCOL 1.83)
		 	(setq EsLIN 2.44)
		 	(setq COLONNE B)
		 	(setq LINEE C)
			 		(if
						  (and
						    (= COLONNE 1)
						    (= LINEE 1)
						   );fine and
					   	(progn
						  (setq TIPO Alfa)
						  (setq sposta (/ escol 2.0))
						  (setq P0 (polar P0 DESTRA sposta))
					  	  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  
					  	);fine progn
					  );fine if A

					  (if
						  (and
						    (= COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Beta)
					  	  (setq sposta (/ escol 2.0))
						  (setq P0 (polar P0 DESTRA sposta))
						  (setq sposta (* eslin (- linee 1.0)))
						  (setq P0 (polar P0 GIU sposta))
						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					    );fine if B

					(if
						  (and
						    (> COLONNE 1)
						    (= LINEE 1)
						   );fine and
						(progn
						  (setq TIPO gamma)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsCOL  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					   );fine if C

					 (if
						  (and
						    (> COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Delta)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta (* eslin (- linee 1.0)))
						  (setq P0 (polar P0 GIU sposta))
						  
					  	  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN EsCOL "" )	;creaa l'array dei blocchi stage 
	
					 	);fine progn
					   );fine if D

			 
			 
			);fine blocco ruotato
			
    	 	 )	;fine cond rotazione blocco

    
    	

  
    	(setq P0 (list assex YCBstage))					;rimette P0  iniziale al centro del back stage!
	(setq FFstage (* eslin LINEE))					;altezza stage installato
	(setq CFstage (POLAR P0 GIU FFstage))				;centro Front stage


	(setq LUNG (* escol COLONNE))
  	(setq ALT  (* eslin LINEE))
	(setq AREA_STAGE  (rtos(* LUNG ALT))) 
	(setq message_stage (strcat  "STAGE " (rtos LUNG)  " x " (rtos ALT)  " surface SqM " AREA_STAGE ))
	;(alert message_stage)
		
	 );fine PING_PONG


 		((= Tstage "Stageright"); INIZIO STAGE RIGHT

		(setq Bloc 2.0) 									;ingombro blocco intero 
		(setq Mibloc (/ Bloc 2))										
  		(setq Blocco "Stage_R")								;nome del blocco

    		(setq A (fix(/ LUNG 2.0 )));colonne possibili con rot 0 
		(setq B (fix(/ LUNG 1.0)));colonne possibili con rot 90 
		(setq C (fix(/ ALT 2.0)));linee possibili con rot 0 
		(setq D (fix(/ ALT 1.0)));linee possibili con rot 90 

		   (if(= A 0)(setq A 1)
	  		(setq A A)
	  		)
			(if(= B 0)
	  		(setq B 1)
	  		(setq B B)
	  		)
			(if(= C 0)
	  		(setq C 1)
		  	(setq C C)
		  	)
			(if(= D 0)
	  		(setq D 1)
	  		(setq D D)
	  	    )
								;------STAGE 1---blocchi  ruotati   0 gradi -----------------------
    	
	    (setq LUNGHEZZA1 (* A 2.0))
	    (setq ALTEZZA1 (* D 1.0))
	    (setq INFO_STAGE1 (* ALTEZZA1 LUNGHEZZA1))

    								;------STAGE 2---blocchi  ruotati   90 gradi -----------------------
    	
    	    (setq LUNGHEZZA2 (* B 1.0))
   	    (setq ALTEZZA2 (* C 2.0))
    	    (setq INFO_STAGE2 (* ALTEZZA2 LUNGHEZZA2))

    								;creazione stringhe messaggio per scelta stage---------
		(setq tLung1 (rtos LUNGHEZZA1 2 2))
		(setq tLung2 (rtos LUNGHEZZA2 2 2))
		(setq tAlt1 (rtos ALTEZZA1 2 2))
		(setq tAlt2 (rtos ALTEZZA2 2 2))
		(setq tinfo1 (rtos INFO_STAGE1 2 2))
		(setq tinfo2 (rtos INFO_STAGE2 2 2))

	

 
	(setq message_stage1 (strcat "stage1 mt " tlung1 " x " talt1  " Sqm " tinfo1 
	" oppure stage2 mt "  tlung2  " x "  talt2   " Sqm " tinfo2 " 1 o 2\n"))

	(initget 1 "stage1 stage2")
	(setq Rot_STAGE (getkword message_stage1))	;determina il tipo di stage scelto 
 

		(if
		     (= Rot_STAGE  "stage1")
  	 	     (setq rot_bloc 0)
    	 	     (setq rot_bloc 90)
   		 )						;determina se il blocco va ruotato di 90 gradi o no e ordina i valori trovati  

    		(Cond   ;cond rotazione blocco
		  	((= rot_bloc 0)
  			(setq EsCOL 2.0)			;spazio tra colonne
			(setq EsLIN 1.0)			;spazio tra linee
			(setq LINEE D)				;quante linee
			(setq COLONNE A)			;quante colonne
					(if
						  (and
						    (= COLONNE 1)
						    (= LINEE 1)
						   );fine and
					   	(progn
						  (setq TIPO Alfa)
						  (setq sposta (/ escol 2))
						  (setq P0 (polar P0 DESTRA sposta))

						  (setq sposta ESLIN)
						  (setq P0 (polar P0 GIU sposta))

						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  
					  	);fine progn
					  );fine if A

					  (if
						  (and
						    (= COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Beta)
					  	  (setq sposta (/ escol 2))
						  (setq P0 (polar P0 DESTRA sposta))
						  (setq sposta (* eslin linee ))
						  (setq P0 (polar P0 GIU sposta))
						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					    );fine if B

					(if
						  (and
						    (> COLONNE 1)
						    (= LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Gamma)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta 	EsLIN)
						  (setq P0 (polar P0 GIU sposta))
						  
						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsCOL  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					   );fine if C

					 (if
						  (and
						    (> COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Delta)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0 )1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta (* eslin linee ))
						  (setq P0 (polar P0 GIU sposta))
						  
					  	  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN EsCOL "" )	;creaa l'array dei blocchi stage 
	
					 	)
					   );fine if D

			 
		    	);fine blocco non ruotato
			 
			((= rot_bloc 90)	;inizio blocco ruotato 
  		 	(setq EsCOL 1.0)
		 	(setq EsLIN 2.0)
		 	(setq COLONNE B)
		 	(setq LINEE C)
			 		(if
						  (and
						    (= COLONNE 1)
						    (= LINEE 1)
						   );fine and
					   	(progn
						  (setq TIPO Alfa)
						  (setq sposta (/ escol 2))
						  (setq P0 (polar P0 DESTRA sposta))
					  	  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  
					  	);fine progn
					  );fine if A

					  (if
						  (and
						    (= COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Beta)
					  	  (setq sposta (/ escol 2))
						  (setq P0 (polar P0 DESTRA sposta))
						  (setq sposta (* eslin (- linee 1)))
						  (setq P0 (polar P0 GIU sposta))
						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					    );fine if B

					(if
						  (and
						    (> COLONNE 1)
						    (= LINEE 1)
						   );fine and
						(progn
						  (setq TIPO gamma)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsCOL  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					   );fine if C

					 (if
						  (and
						    (> COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Delta)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta (* eslin (- linee 1)))
						  (setq P0 (polar P0 GIU sposta))
						  
					  	  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN EsCOL "" )	;creaa l'array dei blocchi stage 
	
					 	);fine progn
					   );fine if D

			 
			 
			);fine blocco ruotato
			
    	 	 )	;fine cond rotazione blocco

    
    	

  
    	(setq P0 (list assex YCBstage))					;rimette P0  iniziale al centro del back stage!
	(setq FFstage (* eslin LINEE))					;altezza stage installato
	(setq CFstage (POLAR P0 GIU FFstage))				;nuovo centro a distanza indicata dal Front stage

	(setq LUNG (* escol COLONNE))
  	(setq ALT  (* eslin LINEE))
	(setq AREA_STAGE  (rtos(* LUNG ALT))) 
	(setq message_stage (strcat  "STAGE " (rtos LUNG)  " x " (rtos ALT)  " surface SqM " AREA_STAGE ))
	;(alert message_stage)

		);fine STAGE RIGHT
;----------inizio dance-------------------------------
;--------inserire qui dancefloor-----------------------------------------


 		((= Tstage "Dance"); INIZIO STAGE RIGHT

		(setq Bloc 0.93) 									;ingombro blocco intero 
		(setq Mibloc (/ Bloc 2))										
  		(setq Blocco_Dance "Dance_F")								;nome del blocco

    		(setq A (fix(/ LUNG 0.93 )));colonne possibili con rot 0 
		(setq B (fix(/ LUNG 0.93)));colonne possibili con rot 90 
		(setq C (fix(/ ALT 0.93)));linee possibili con rot 0 
		(setq D (fix(/ ALT 0.93)));linee possibili con rot 90 

		   (if(= A 0)(setq A 1)
	  		(setq A A)
	  		)
			(if(= B 0)
	  		(setq B 1)
	  		(setq B B)
	  		)
			(if(= C 0)
	  		(setq C 1)
		  	(setq C C)
		  	)
			(if(= D 0)
	  		(setq D 1)
	  		(setq D D)
	  	    )
								;------STAGE 1---blocchi  ruotati   0 gradi -----------------------
    	
	    (setq LUNGHEZZA1 (* A 0.93))
	    (setq ALTEZZA1 (* D 0.93))
	    (setq INFO_STAGE1 (* ALTEZZA1 LUNGHEZZA1))

    								;------STAGE 2---blocchi  ruotati   90 gradi -----------------------
    	
    	    (setq LUNGHEZZA2 (* B 0.93))
   	    (setq ALTEZZA2 (* C 0.93))
    	    (setq INFO_STAGE2 (* ALTEZZA2 LUNGHEZZA2))

    								;creazione stringhe messaggio per scelta stage---------
		(setq tLung1 (rtos LUNGHEZZA1 2 2))
		(setq tLung2 (rtos LUNGHEZZA2 2 2))
		(setq tAlt1 (rtos ALTEZZA1 2 2))
		(setq tAlt2 (rtos ALTEZZA2 2 2))
		(setq tinfo1 (rtos INFO_STAGE1 2 2))
		(setq tinfo2 (rtos INFO_STAGE2 2 2))

	

 
	(setq message_stage1 (strcat "stage1 mt " tlung1 " x " talt1  " Sqm " tinfo1 
	" oppure stage2 mt "  tlung2  " x "  talt2   " Sqm " tinfo2 " 1 o 2\n"))

	;(initget 1 "stage1 stage2")
	(setq Rot_STAGE "stage1")	;determina il tipo di stage scelto 
 

		(if
		     (= Rot_STAGE  "stage1")
  	 	     (setq rot_bloc 0)
    	 	     (setq rot_bloc 90)
   		 )						;determina se il blocco va ruotato di 90 gradi o no e ordina i valori trovati  

    		(Cond   ;cond rotazione blocco
		  	((= rot_bloc 0)
  			(setq EsCOL 0.93)			;spazio tra colonne
			(setq EsLIN 0.93)			;spazio tra linee
			(setq LINEE D)				;quante linee
			(setq COLONNE A)			;quante colonne
					(if
						  (and
						    (= COLONNE 1)
						    (= LINEE 1)
						   );fine and
					   	(progn
						  (setq TIPO Alfa)
						  (setq sposta (/ escol 2))
						  (setq P0 (polar P0 DESTRA sposta))

						  (setq sposta ESLIN)
						  (setq P0 (polar P0 GIU sposta))

						  (command "_insert" Blocco P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  
					  	);fine progn
					  );fine if A

					  (if
						  (and
						    (= COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Beta)
					  	  (setq sposta (/ escol 2))
						  (setq P0 (polar P0 DESTRA sposta))
						  (setq sposta (* eslin linee ))
						  (setq P0 (polar P0 GIU sposta))
						  (command "_insert" Blocco_dance P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					    );fine if B

					(if
						  (and
						    (> COLONNE 1)
						    (= LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Gamma)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta 	EsLIN)
						  (setq P0 (polar P0 GIU sposta))
						  
						  (command "_insert" Blocco_dance P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsCOL  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					   );fine if C

					 (if
						  (and
						    (> COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Delta)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0 )1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta (* eslin linee ))
						  (setq P0 (polar P0 GIU sposta))
						  
					  	  (command "_insert" Blocco_dance P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN EsCOL "" )	;creaa l'array dei blocchi stage 
	
					 	)
					   );fine if D

			 
		    	);fine blocco non ruotato
			 
			((= rot_bloc 90)	;inizio blocco ruotato 
  		 	(setq EsCOL 0.93)
		 	(setq EsLIN 0.93)
		 	(setq COLONNE B)
		 	(setq LINEE C)
			 		(if
						  (and
						    (= COLONNE 1)
						    (= LINEE 1)
						   );fine and
					   	(progn
						  (setq TIPO Alfa)
						  (setq sposta (/ escol 2))
						  (setq P0 (polar P0 DESTRA sposta))
					  	  (command "_insert" Blocco_dance P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  
					  	);fine progn
					  );fine if A

					  (if
						  (and
						    (= COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Beta)
					  	  (setq sposta (/ escol 2))
						  (setq P0 (polar P0 DESTRA sposta))
						  (setq sposta (* eslin (- linee 1)))
						  (setq P0 (polar P0 GIU sposta))
						  (command "_insert" Blocco_dance P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					    );fine if B

					(if
						  (and
						    (> COLONNE 1)
						    (= LINEE 1)
						   );fine and
						(progn
						  (setq TIPO gamma)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (command "_insert" Blocco_dance P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsCOL  "" )	;creaa l'array dei blocchi stage 
	
					 	)
					   );fine if C

					 (if
						  (and
						    (> COLONNE 1)
						    (> LINEE 1)
						   );fine and
						(progn
						  (setq TIPO Delta)
					  	  (setq sposta 	(* escol (- (/ COLONNE 2.0)1.0)))
						  (setq P0 (polar P0 SINISTRA sposta))
						  (setq sposta (* eslin (- linee 1)))
						  (setq P0 (polar P0 GIU sposta))
						  
					  	  (command "_insert" Blocco_dance P0 "" "" rot_bloc)			;inserisce il primo blocco in P0
    						  (setq OB2 (entlast))
						  (command "_array" OB2 "" "r" LINEE COLONNE EsLIN EsCOL "" )	;creaa l'array dei blocchi stage 
	
					 	);fine progn
					   );fine if D

			 
			 
			);fine blocco ruotato
			
    	 	 )	;fine cond rotazione blocco

    
    	

  
    	(setq P0 PP0)							;rimette P0  iniziale al centro del back stage!
	(setq FFstage (* eslin LINEE))					;altezza stage installato
	(setq CFstage (POLAR P0 GIU FFstage))				;nuovo centro a distanza indicata dal Front stage

	(setq LUNG (* escol COLONNE))
  	(setq ALT  (* eslin LINEE))
	(setq AREA_STAGE  (rtos(* LUNG ALT))) 
	(setq message_dance (strcat  "DANCE_Floor " (rtos LUNG)  " x " (rtos ALT)  " surface SqM " AREA_STAGE ))
	;(alert message_stage)			;messaggio stage 
		)			;fine DANCEFLOOR

			
			
	);fine YES
    	)
        
   
	((= STAGE "No" )							;senza stage

	(setq YCBstage (- Yz2 Bstage ))					;centro back stage
        (setq P0 (list assex YCBstage))					;punto inserzione stage
 	(setq LUNG 0)
	 (setq ALT 0)
	 );fine del NO

	
 );fine STAGE
	;fine stage-------------------
 ;)
  	(setq P1 Z3)
	(setq Z3 (list SM  DB))						;zona setup angolo basso sin  
	(setq P1 Z3)
	
    	(setq Z2 (POLAR Z2 SINISTRA SM))
  	(setq Z4 (POLAR Z2 GIU Bstage))					
	(setq Z4 (POLAR Z4 GIU ALT))
  	(setq XZ5 (car z4))
	(setq YZ5 (cadr z3))
  	(setq Z5 (list Xz5 Yz5))					;creo il punto Z5
	;(command "_line" Z4 Z3 "")      ;TEST PER VEDERE SE Z4 e Z3 sono corretti 
  	(princ)
	(princ)
  

;------------------------INIZIO SETUP----------------------------------
	(initget 1 "Yes No")
  	(setq SET_inst (getkword "\nIstaller le SETUP? Yes or No\n"))	;determina il tipo scelto 


(cond;cond globale di tutto il setup
  	((= SET_inst "No")
  		(princ)
       		(princ)
    	);se non vuoi il setup finisce

      ((= SET_inst "Yes")

(if (not (tblsearch "LAYER" "!SETUP"))
  (progn
   (setq regen (getvar "REGENMODE"))
   (setvar "REGENMODE" 0)
   (command "_layer" "_m" "!SETUP")
   (command "_c" "7" "!SETUP")		;colore bianco
   (command "")
   (setvar "REGENMODE" regen)
  )
 )

 ; rende attivo il layer !SETUP

 (command "_layer" "_s" "!SETUP" "")
 (command "_color" "BYLAYER")


(setq Z4 (POLAR Z4 GIU (getdist "\nDistanza da FRONT STAGE\n")))
       	(initget 1 "Theatre Classe Banquet")
  	(setq SETUP (getkword "\nSetup Theatre Classe Banquet\n"))	;determina il tipo scelto 
	

 (cond
  ((= "Theatre" SETUP)
     	(setq EcX 0.5)				;distance fixe entre chaise a changer pour classe etc etc 
	(setq Ecy 1) 				;distanza fixe entre colonne pour chaise a changer pour ecole etc 
	(setq Mibloc 0.2101)			;mezza sedia
  	(setq Bloc (* 2 Mibloc)) 		;ingombro sedia intera 
	(setq Blocco_setup "CHAISE")			;nome del blocco
	(setq P1 (POLAR P1 DESTRA mibloc))
	(setq P1 (POLAR P1 SU (+ bloc 0.0742)))
	(setq scorr (/ Bloc 2))			;spazio per i corridoi
	(setq COMP mibloc)			;spazio per i corridoi

   );fine theatre

((= "Classe" SETUP)
     	(setq EcX 2.43)				;distance fixe entre chaise a changer pour classe etc etc 
	(setq Ecy 1.75) 				;distanza fixe entre colonne pour chaise a changer pour ecole etc 
	(setq Mibloc 1.215)			;mezza sedia
  	(setq Bloc (* 2 Mibloc)) 		;ingombro sedia intera 
	(setq Blocco_setup "ECOLE_8")			;nome del blocco
	(setq P1 (POLAR P1 DESTRA bloc))
	(setq P1 (POLAR P1 SU Ecy))
	(setq scorr mibloc)
	(setq COMP 0)			;spazio per i corridoi

 );fine classe
  
((= "Banquet" SETUP)
	(setq Mibloc 1.4142)										;mezza sedia
  	(setq Bloc (* 2 Mibloc)) 									;ingombro sedia intera 
	(setq Blocco_setup "TAB10_182")									;nome del blocco
 	(setq EcX (+ Bloc(getreal "\nDistance entre tables en X\n")))					;distance fixe entre chaise a changer pour classe etc etc 
	(setq Ecy Ecx) 											;distanza fixe entre colonne pour chaise a changer pour ecole etc 
	(setq P1 (POLAR P1 DESTRA mibloc))
	(setq P1 (POLAR P1 SU mibloc))
	(setq scorr 0)
	(setq COMP mibloc)										;compensazione per la centratura
  );fine banquet

 )	;fine delle condizioni del SETUP
  
  (setq P2 Z4);
  (setq xZ5 (car Z3))			  ;primo elem di z3
  
  (setq yZ5 (cadr Z4))			  ;secondo emem di z4 
  (setq Distx (- distzona (* 2 SM)))      ;zona di setup	
  (setq Disty (- yz5 DB))		  ;zona di setup
  ;(setq X (fix Distx))
  ;(setq Y (fix Disty))

  					;variabili di spostamento blocchi
  
(setq COL (/ Distx  ECx))
(setq tcol (rtos COL 2 2 )) ;rtos per convertire il numero reale in stringa 
(setq LIN (/ Disty  ECy))
(setq tlin (rtos LIN 2 2))

(setq message_col (strcat tcol "  colonne e " tlin " linee" ))
(princ message_col)						;messaggio colonne e linee inserire


(setq PAKS (getint "\nQuanti packs?\n"))			;1 gruppo = 0 alles

	(cond
			((= PAKS  1.0)			;1 gruppo vuol dire zero corridoi
			(setq COULOIRS PAKS)
			(setq Cor 0.0)		;largeur alles de securit
			)
			(
			(setq COULOIRS PAKS)
			(setq Cor (getreal "\nlarg corridoio\n" ))		;largeur alles de securit
			)
	)
  
(setq sec  (+ Cor bloc))					;compensazione rispetto ai punti di inserzione dei bocchi
(setq distx (- distx (* couloirs Cor)))


(setq COL (/ Distx  ECx))
(setq tcol (rtos COL 2 2 )) 				;rtos per convertire il numero reale in stringa 
(setq LIN (/ Disty  ECy))
(setq tlin (rtos LIN 2 2))


(setq message_col (strcat tcol "  colonne e " tlin " linee" ))
(terpri)
(princ message_col)						;messaggio colonne e linee inserire




(setq N COULOIRS)		;determina il numero di colonne da creare
(setq LIN (fix LIN))		;lignes a repeter en array

(setq DIV (rtos(/ col n))) 					;stringa minimo blocchi
(setq RDIV (rtos(fix(rem col n)))) 					;stringa resto della divisione blocchi
(setq message_col (strcat DIV " blocchi "  "resto " RDIV " blocchi " tcol " colonne e " tlin " linee"))
(terpri)
(princ message_col)						;messaggio colonne e linee inserire

(setq ss nil)    	;svuota ss
(setq ss  (ssadd))	;crea unaselezione vuota
  (repeat N 			;quante rengee repeat 2

 	  	(repeat (getint "\nNumero blocchi per fila\n") 				;quanti blocchi repeat 1
    		(command "_insert" Blocco_setup P1 "" "" "")			;inserisce il primo blocco in P1
    		(setq OB2 (entlast ))
		(setq ss (ssadd   ob2 ss )) 					;aggiunge alla selezione ss il blocco creato
		(setq P1 (POLAR P1 DESTRA Ecx))
    	);fine rapeat 1
  	(setq P1 (POLAR P1 DESTRA cor))			;primo corridoio

   );fine repeat N range
	
  (setq ssl (sslength ss));conta quanti blocchi nella prima linea 
   
  ;(command "_group" "" "L1" "" ss "" "") 		;crea un gruppo	chiamato L1 
 (setq P1 (polar P1 DESTRA (+ mibloc COMP)))			;mette p1 alpunto di inserzione dell'ultimo blocco della riga 
 (setq xp1 (car p1))					;coord x del p1 finale
 (setq SPOSTA (/ 2.0 (- xz5 xp1)))


  
(setq P1 (polar P1 sinistra sec))					;spazio dai muri destro e sin  
(setq P1 (polar P1 sinistra ecx))
(setq P1 (polar P1 destra  mibloc))
(setq xp1 (car p1))
(setq xp2 (car p2))

(setq INSERITI (- (sslength SS) 1))			;quanti blocchi effettivamente inseriti sulla prima linea 
(setq SOCCU (* bloc INSERITI))				;spazio realmente occupato dai blocchi inseriti
(setq SV (* (- N 1 ) Cor))				;spazio dei corridoi
(setq SOCCU (+ SV  SOCCU))				;spazio occupato 

(setq XZ5 (car z4))
(setq YZ5 (cadr z3))
  	

(setq RESTO (/(- xz5 xp1)2))
(setq ESlin ecy)  

;(setq ss1 nil)    	;svuota ss
;(setq ss1  (ssadd))	;crea unaselezione vuota


(setq PS (polar P1 DESTRA RESTO ))			;punto creato epr centrare i blocchi test con scor oppure con resto 
(command "_move" ss "" P1 PS "")			;centra la prima linea 


  ;(repeat (-  LIN 1)			;quante rengee repeat 2

 ;	  	(command "_copy" ss "" z3 (polar z3 SU ESlin))			;inserisce il primo blocco in P1
  ;  		(setq OB2 (entlast ))
;		(setq Eslin (+ ESlin ecy))
 ; 		(setq ss1 (ssadd   ob2 ss ))
		 ;( setq ssA OB2 )
		 ;(setq ss (ssadd ss ssA 0))
		  ;(setq ss (ssadd)
		;(setq ss (ssadd OB2 ss));aggiunta oggi
	  	;(setq 
    		(setq P1 (POLAR P1 DESTRA Ecx))
  ;  	);fine rapeat 1
  ;(setq ssl1 (sslength ss1));conta quanti blocchi nella prima linea 
  

  
(command "_array" SS "" "r" LIN 1  Ecy "" )		;array solo per le linee le colonne sono gia fatte;

;(setq DatiB (entget OB2))				;estrae tutte le informazioni del blocco
;(setq Nlist (list (cons 0 "insert")(cons 2 Blocco_setup))) 	;nome del blocco 
;(setq SS1 (ssget "X" Nlist))				; blocchi selezionati
;(setq ss1 (ssget "_C" z3 z4 ))
(setq count (rtos (* LIN  ssl)))	;quanti blocchi inseriti realmente con setup? 
(setq message_setup (strcat   count "   "  Blocco_setup  ))
;(alert message_setup)			;messaggio stage 
	

 (setvar "osmode" OSN);rimette lo snap
(setq ss nil)
  );fine setup yes
       	);fine di setup GLOBALE?

(setvar "osmode" OSN);rimette lo snap come prima
;(command "_UCS" "_W" );rimette l'ucs generale

(setq count (rtos (* (+ inseriti 1) lin)))		;quanti blocchi inseriti realmente con setup? 

(princ)

 
);fine defun



(defun C:I_STAGE()
(setq P2 (getpoint "\nPOINT INFO?"))
(setq P (getpoint "\nPOINT INFO?"))
(command "_line" P2 p "")
(setq P (polar P SU 0.3))
(command "_text" P 0  message_stage "")
  ;(alert message)
	)



(defun C:I_SETUP()
(setq P2 (getpoint "\nPOINT INFO?"))
(setq P (getpoint "\nPOINT INFO?"))
(command "_line" P2 p "")
(setq P (polar P SU 0.3))
(command "_text" P 0  message_setup "")
  ;(alert message)
	)



(defun C:I_DANCE()
(setq P2 (getpoint "\nPOINT INFO?"))
(setq P (getpoint "\nPOINT INFO?"))
(command "_line" P2 p "")
(setq P (polar P SU 0.3))
(command "_text" P 0  message_DANCE "")
  ;(alert message)
	)