;viste 2d e3d con rapidi shortcuts +
;opzopni per operazioni booleane e visualizzazioni wireframe shade 

(defun C:w1  (/ w1)
  (command  "_-view" "isoso" "" );vista iso so
 )


(defun C:w2  (/ w1)
  (command  "_-view" "isose" "" );vista iso se
 )

(defun C:w3  (/ w3)
  (command  "_-view" "isone" "" );vista iso ne
 )

(defun C:w4  (/ w4)
  (command  "_-view" "isono" "" );vista iso no
 )

(defun C:v7  (/ v7)
  (command  "_-view" "G" "H" );vista Haut
 )

(defun C:top  (/ top)
  (command  "_-view" "G" "H" );vista Haut
 )


(defun C:v77  (/ v77)
  (command  "_-view" "G" "B" );vista Basso
 )

(defun C:v3  (/ v3)
  (command  "_-view" "G" "D" );vista Destra
 )

(defun C:side  (/ side)
  (command  "_-view" "G" "D" );vista Destra
 )


(defun C:v33  (/ v33)
  (command  "_-view" "G" "G" );vista Sinistra
 )

(defun C:v1  (/ v1)
  (command  "_-view" "G" "A" );vista Avanti o FACE
 )


(defun C:face  (/ face)
  (command  "_-view" "G" "A" );vista Avanti o FACE
 )




(defun C:v11  (/ v11)
  (command  "_-view" "G" "AR" );vista ARriere o dietro
 )

(defun C:e  (/ e)
  (command  "_extrude");vista ARriere o dietro
 )



;tipi di visualizzazione 

(defun C:wire  ()
  (command  "_shademode" "2"  );2d Fil di ferro
 )

(defun C:hide  ()
  (command  "_shademode" "3"  );2d Fil di ferro
 )

(defun C:shade  ()
  (command  "_shademode" "g" ""  );2d Fil di ferro
 )


(defun C:zz  (/ zz)
  (command  "_zoom" "c"   );zoom centrato con specifica dimensioni 
 )






(defun C:+  (/ +)
  (command  "_union"  );Operazione booleana unione 
 )

(defun C:-  (/ +)
  (command  "_subtract"  );Operazione booleana sottrazione A-B il secondo oggetto  sottratto al primo 
 )

(defun C:*  (/ *)
  (command  "_intersect"  );Operazione booleana intersezione  A * B il tiene solo quello che  comune ai due oggetti 
 )






;-------------------spostamenti alla blender-----------------------

(defun c:gx()
(setq X (getreal "\nSposta X:"))
(prompt "\nSelezione delle entit a cui cambiare la x...")
(setq _ss (ssget))
(setq _a (list 0.00 0.00 0.00) _b (list X 0.00 0.00))
(if _ss
(command "_MOVE" _ss "" _A _B)
)
)



(defun c:gy()
(setq Y (getreal "\nSposta  Y:"))
(prompt "\nSelezione delle entit a cui cambiare la y...")
(setq _ss (ssget))
(setq _a (list 0.00 0.00 0.00) _b (list 0.00 Y 0.00))
(if _ss
(command "_MOVE" _ss "" _A _B)
)
)


(defun c:gz()
(setq Z (getreal "\nSposta Z:"))
(prompt "\nSelezione delle entit a cui cambiare la z...")
(setq _ss (ssget))
(setq _a (list 0.00 0.00 0.00) _b (list 0.00 0.00 Z))
(if _ss
(command "_MOVE" _ss "" _A _B)
)
)



;---CREA UNA SCALA IN 3D -----------------------------------------

(defun C:SCALA ()
;(setvar "CMDECHO" 0)
(setvar "osmode" 3)
(command "_ucs" "t" "a" "")    
(setq px2 nil)
(setq px3 nil)
  
(setq DTR (/ PI 180))		;fattore di moltiplicazione x gradi verso radianti  pi  Pi greco!
(setq DESTRA (* 0 DTR))		;traduzione del comando polar  
(setq SINISTRA (* 180 DTR))	;traduzione del comando polar 
(setq SU (* 90 DTR))		;traduzione del comando polar 
(setq GIU (* 270 DTR))		;traduzione del comando polar 
(setq DIAG (* 45 DTR))		;traduzione del comando polar x 45 gradi
  

(command "_ucs" "t" "a" "")
    	
  (setq alz (getdist "\nAlzata m :  ")   ;richiesta parametri utente 
         ped (getdist "\nPedata m :  ")
         ng  (getdist "\nNumero di gradini :  ")  
         LARG (getdist "\nLargezza ? :")
    	
	 px  (getpoint "\nPunto iniziale RAMPA :  ")
	 px1 (list px)                
         spess (* ng ped)
	 px1b px   ;;;;;;;;;;;;;;;;;;;;;;;;;;
	  
   );setq calcoli

    (setvar "osmode" 0)
  
   (setq cont 1                   	;contatore
	 a  (polar px SU alz)  		; alzata
         p  (polar a  DESTRA ped)  	;pedata
         
	   );setq calcoli
   (command "_pline" px "_W" "0" "" a p "")      ;primo gradino e spessore della linea
    (setq e1 (entlast))
        (WHILE (/= cont ng)

	  (setq a (polar p SU alz);imposta gradino successivo
               
	  ;(setq a (polar p 1.57079 alz);imposta gradino successivo
                     px p
                     p (polar a 0.00000 ped); 
               );
               (command "_pline" px a p "")             ;edita la polilinea
               (setq e2 (entlast))
              (setq cont (+ 1 cont));incremento contatore
       (command "_pedit" e2 "_j" e1 e2 "" "")
              (setq e1 (entlast))       
        );fine ciclo

  
	(setq long(* ng ped))			;ok	 

	(setq cpx1 (car px1))
  	(setq xpx1 (car cpx1))			;coordinata X
  	(setq ypx1 (cadr cpx1))			;coordinata Y
  	(setq zpx1 (caddr cpx1))		;coordinata Z
	
  	(setq xpx2 (+ long xpx1))
  	;;;;;;;;;;;;;;(setq px2 (list xpx2 ypx1 zpx1))         ;;;;;;;;;;;;;;;;;;;;;;;
	(setq px2 (polar px1b DESTRA (* ng ped)))              ;;;;;;;;;;;;;;;;;;;;;;
        (setq px3 (polar px2 SU (* ng alz)))                   ;;;;;;;;;;;;;;;;;;;;;;
    	(setq ypx3(+ ypx1 long))
  	
  	(command "_pline"  px1b px2 px3  "")    ;chiude il profilo
	(setq e4 (entlast))
    	(command "_pedit" e1 "_j" e1 e4 "" "")	;unisce tutto in un unica pline 
    	(setq e5 (entlast))
    	(command "_extrude" e5 "" LARG "" "") 	;estrude la pline
        (setq e6 (entlast))			;scala estrusa 

  	(command "_ucs" "t" "h" "")
    	(command "_move" e6 "" px1b (polar px1b SU (/ LARG 2)))
	(command "_move" e6 "" px1b (polar px1b SINISTRA spess))
	
  	;(command "_ucs" "t" "a" "")
    	;(command "_rotate" e6 "" pxb1 DESTRA "") 
	;(command "_ucs" "t" "h" "")

  	(setvar "osmode" 3 )
  	
  	
  
	);defun



;______CUBO_________________________________________________________________________________________

(defun C:CUBO ()

(setq DTR (/ PI 180))		;fattore di moltiplicazione x gradi verso radianti  pi  Pi greco!
	(setq DESTRA (* 0 DTR))		;traduzione del comando polar  
	(setq SINISTRA (* 180 DTR))	;traduzione del comando polar 
	(setq SU (* 90 DTR))		;traduzione del comando polar 
	(setq GIU (* 270 DTR))		;traduzione del comando polar 
	(setq DIAG (* 45 DTR))		;traduzione del comando polar x 45 gradi 

(SETQ OSN (GETVAR "OSMODE"))						;salva gli snap  

(SETVAR "OSMODE" 3)							;salva gli snap  

	(setq P0 (getpoint "\nPunto inserzione CUBO: ?\n"))
  	(setq PP0 P0)
  	(setvar "osmode" 0)
  
  	(setq LUNG (getdist "\nLUNGHEZZA X ?\n"))		;	dimensioni utilizzatore stage
        (setq ALT  (getdist "\nLARHEZZA Y ?\n"))		;	dimensioni utilizzatore stage
	(setq estr (getdist "\nALTEZZA Z ?\n"))
    			
  			(setq As (POLAR P0 SINISTRA (/ LUNG 2.0))) 
			(setq Bs (POLAR As GIU ALT))
			(setq Cs (POLAR Bs DESTRA LUNG))
			(setq Ds (POLAR Cs SU ALT ))      
			(command "_pline" As Bs Cs Ds "c" );disegna la polilinea stage centrata nello spazio
			(setq e5 (entlast))
			(command "_extrude" e5 "" estr "" "") 	;estrude la pline
			 
		 	;(setq P0 (list assex YCBstage))					;rimette P0  iniziale al centro del back stage!
		 	;(setq FFstage (* eslin LINEE))					;altezza stage installato
			;(setq CFstage (POLAR P0 GIU FFstage))				;centro Front stage

			
)
