;CONV modif del 15 01 2004
;stage, setup piu info in finale 

(defun C:SETUP ()

(setq DTR (/ PI 180))		;fattore di moltiplicazione x gradi verso radianti  pi  Pi greco!
(setq DESTRA (* 0 DTR))		;traduzione del comando polar  
(setq SINISTRA (* 180 DTR))	;traduzione del comando polar 
(setq SU (* 90 DTR))		;traduzione del comando polar 
(setq GIU (* 270 DTR))		;traduzione del comando polar 
(setq DIAG (* 45 DTR))		;traduzione del comando polar x 45 gradi 

(SETQ OSN (GETVAR "OSMODE"))						;salva gli snap  

(SETVAR "OSMODE" 3)							;salva gli snap  

  (setq Z1 (getpoint "\nseleziona ZONA angolo in basso a sinistra"))
  (command "_ucs" "o" Z1)						;mette l'origine in z1
  (setq Z1 (list 0 0 ))	
  (setq Z2 (getpoint "\nseleziona ZONA angolo alto destra "))		;trova il punto z2
  (setvar "osmode" 0)							;toglie lo snap 

  (setq xZ1(car Z1))
  (setq yZ1(cadr Z1))
  (setq xz2 (car z2))
  (setq yz2(cadr z2))
  (setq asseX(/ xz2 2))							;coordinata del centro asse X dello spazio
  (Setq Z11 (list xz2 yz1))
  (setq distzona (distance Z1 Z11))					;distanza massima senza corridoi

	(setq Bstage (getdist "\nEspace Back STAGE?\n"))		;spazio dal fondo 
        (setq YCBstage (- Yz2 Bstage ))					;centro back stage
        (setq P0 (list assex YCBstage))					;punto inserzione stage

        (setq SM  (getdist "\nSpazio laterale dai muri?\n"))		;distanza dai muri laterali 
	(setq DB (getdist "\nSpazio dalla REGIA?\n"))			;distanza dal fondo sala 


; se non esiste il layer SIMBOLI lo crea

  
 (if (not (tblsearch "LAYER" "!SETUP"))
  (progn
   (setq regen (getvar "REGENMODE"))
   (setvar "REGENMODE" 0)
   (command "_layer" "_m" "!SETUP")
   (command "_c" "7" "!SETUP")		;colore bianco
   (command "")
   (setvar "REGENMODE" regen)
  )
 )

 ; rende attivo il layer SIMBOLI

 (command "_layer" "_s" "!SETUP" "")
 (command "_color" "BYLAYER")

  
  	
   
	
	(setq YCBstage (- Yz2 Bstage ))					;centro back stage
        (setq P0 (list assex YCBstage))					;punto inserzione stage
 	(setq LUNG 0)
	(setq ALT 0)


  	(setq P1 Z3)
	(setq Z3 (list SM  DB))						;zona setup angolo basso sin  
	(setq P1 Z3)
	
    	(setq Z2 (POLAR Z2 SINISTRA SM))
  	(setq Z4 (POLAR Z2 GIU Bstage))					
	(setq Z4 (POLAR Z4 GIU ALT))
  	(setq XZ5 (car z4))
	(setq YZ5 (cadr z3))
  	(setq Z5 (list Xz5 Yz5))					;creo il punto Z5
	;(command "_line" Z4 Z3 "")      ;TEST PER VEDERE SE Z4 e Z3 sono corretti 
  	(princ)
	(princ)
  

	(setq Z4 (POLAR Z4 GIU (getdist "\nDistanza da FRONT STAGE\n")))
       	(initget 1 "Theatre Classe Banquet")
  	(setq SETUP (getkword "\nSetup Theatre Classe Banquet\n"))	;determina il tipo scelto 
	

 (cond
  ((= "Theatre" SETUP)
     	(setq EcX 0.5)				;distance fixe entre chaise a changer pour classe etc etc 
	(setq Ecy 1) 				;distanza fixe entre colonne pour chaise a changer pour ecole etc 
	(setq Mibloc 0.2101)			;mezza sedia
  	(setq Bloc (* 2 Mibloc)) 		;ingombro sedia intera 
	(setq Blocco_setup "CHAISE")			;nome del blocco
	(setq P1 (POLAR P1 DESTRA mibloc))
	(setq P1 (POLAR P1 SU (+ bloc 0.0742)))
	(setq scorr (/ Bloc 2))			;spazio per i corridoi
	(setq COMP mibloc)			;spazio per i corridoi

   );fine theatre

((= "Classe" SETUP)
     	(setq EcX 2.43)				;distance fixe entre chaise a changer pour classe etc etc 
	(setq Ecy 1.75) 				;distanza fixe entre colonne pour chaise a changer pour ecole etc 
	(setq Mibloc 1.215)			;mezza sedia
  	(setq Bloc (* 2 Mibloc)) 		;ingombro sedia intera 
	(setq Blocco_setup "ECOLE_8")			;nome del blocco
	(setq P1 (POLAR P1 DESTRA bloc))
	(setq P1 (POLAR P1 SU Ecy))
	(setq scorr mibloc)
	(setq COMP 0)			;spazio per i corridoi

 );fine classe
  
((= "Banquet" SETUP)
	(setq Mibloc 1.4142)										;mezza sedia
  	(setq Bloc (* 2 Mibloc)) 									;ingombro sedia intera 
	(setq Blocco_setup "TAB10_182")									;nome del blocco
 	(setq EcX (+ Bloc(getreal "\nDistance entre tables en X\n")))					;distance fixe entre chaise a changer pour classe etc etc 
	(setq Ecy Ecx) 											;distanza fixe entre colonne pour chaise a changer pour ecole etc 
	(setq P1 (POLAR P1 DESTRA mibloc))
	(setq P1 (POLAR P1 SU mibloc))
	(setq scorr 0)
	(setq COMP mibloc)										;compensazione per la centratura
  );fine banquet

 )	;fine delle condizioni del SETUP
  
  (setq P2 Z4);
  (setq xZ5 (car Z3))			  ;primo elem di z3
  
  (setq yZ5 (cadr Z4))			  ;secondo emem di z4 
  (setq Distx (- distzona (* 2 SM)))      ;zona di setup	
  (setq Disty (- yz5 DB))		  ;zona di setup
  ;(setq X (fix Distx))
  ;(setq Y (fix Disty))

  					;variabili di spostamento blocchi
  
(setq COL (/ Distx  ECx))
(setq tcol (rtos COL 2 2 )) ;rtos per convertire il numero reale in stringa 
(setq LIN (/ Disty  ECy))
(setq tlin (rtos LIN 2 2))

(setq message_col (strcat tcol "  colonne e " tlin " linee" ))
(princ message_col)						;messaggio colonne e linee inserire


(setq PAKS (getint "\nQuanti packs?\n"))			;1 gruppo = 0 alles

	(cond
			((= PAKS  1.0)			;1 gruppo vuol dire zero corridoi
			(setq COULOIRS PAKS)
			(setq Cor 0.0)		;largeur alles de securit
			)
			(
			(setq COULOIRS PAKS)
			(setq Cor (getreal "\nlarg corridoio?\n" ))		;largeur alles de securit
			)
	)
  
(setq sec  (+ Cor bloc))					;compensazione rispetto ai punti di inserzione dei bocchi
(setq distx (- distx (* couloirs Cor)))


(setq COL (/ Distx  ECx))
(setq tcol (rtos COL 2 2 )) 				;rtos per convertire il numero reale in stringa 
(setq LIN (/ Disty  ECy))
(setq tlin (rtos LIN 2 2))


(setq message_col (strcat tcol "  colonne e " tlin " linee" ))
(terpri)
(princ message_col)						;messaggio colonne e linee inserire




(setq N COULOIRS)		;determina il numero di colonne da creare
(setq LIN (fix LIN))		;lignes a repeter en array

(setq DIV (rtos(/ col n))) 					;stringa minimo blocchi
(setq RDIV (rtos(fix(rem col n)))) 					;stringa resto della divisione blocchi
(setq message_col (strcat DIV " blocchi "  "resto " RDIV " blocchi " tcol " colonne e " tlin " linee"))
(terpri)
(princ message_col)						;messaggio colonne e linee inserire

(setq ss nil)    		;svuota ss
(setq ss  (ssadd))		;crea unaselezione vuota
   (repeat N 			;quante colonne repeat 

 	(repeat (getint "\nQuanti blocchi?\n") 					;quanti blocchi repeat 1
    		(command "_insert" Blocco_setup P1 "" "" "")			;inserisce il primo blocco in P1
    		(setq OB2 (entlast ))
		(setq ss (ssadd   ob2 ss )) 					;aggiunge alla selezione ss il blocco creato
		(setq P1 (POLAR P1 DESTRA Ecx))
   	);fine rapeat 2

     	(setq P1 (POLAR P1 DESTRA cor))						;crea i corridoi 

   );fine repeat N range
	
  (setq ssl (sslength ss))							;conta quanti blocchi inseriti  nella prima linea 
   
  										;(command "_group" "" "L1" "" ss "" "") 		;crea un gruppo	chiamato L1 
 (setq P1 (polar P1 DESTRA (+ mibloc COMP)))			;mette p1 alpunto di inserzione dell'ultimo blocco della riga 
 (setq xp1 (car p1))						;coord x del p1 finale
 (setq SPOSTA (/ 2.0 (- xz5 xp1)))


  
(setq P1 (polar P1 sinistra sec))					;spazio dai muri destro e sin  
(setq P1 (polar P1 sinistra ecx))
(setq P1 (polar P1 destra  mibloc))
(setq xp1 (car p1))
(setq xp2 (car p2))

(setq INSERITI (- (sslength SS) 1))			;quanti blocchi effettivamente inseriti sulla prima linea 
(setq SOCCU (* bloc INSERITI))				;spazio realmente occupato dai blocchi inseriti
(setq SV (* (- N 1 ) Cor))				;spazio dei corridoi
(setq SOCCU (+ SV  SOCCU))				;spazio occupato 

(setq XZ5 (car z4))
(setq YZ5 (cadr z3))
  	

(setq RESTO (/(- xz5 xp1)2))
(setq ESlin ecy)  


(setq PS (polar P1 DESTRA RESTO ))			;punto creato epr centrare i blocchi test con scor oppure con resto 
(command "_move" ss "" P1 PS "")			;centra la prima linea 

(setq P1 (POLAR P1 DESTRA Ecx))
  
(command "_array" SS "" "r" LIN 1  Ecy "" )			;array solo per le linee le colonne sono gia fatte;

(setq count (rtos (* LIN  ssl)))				;conta quanti blocchi inseriti realmente con setup? 
(setq message_setup (strcat   count "   "  Blocco_setup  ))	;creazione messaggio
								;(alert message_setup)						;messaggio stage 
	

(setvar "osmode" OSN)						;rimette lo snap
(setq ss nil)							;risvuota ss per un riutilizzo dello script
(command "_UCS" "_W" )						;rimette l'ucs generale
(princ)

 
);fine defun



(defun C:I_STAGE()
(setq P2 (getpoint "\nPOINT INFO?"))
(setq P (getpoint "\nPOINT INFO?"))
(command "_line" P2 p "")
(setq P (polar P SU 0.3))
(command "_text" P 0  message_stage "")
  ;(alert message)
	)



(defun C:I_SETUP()
(setq P2 (getpoint "\nPOINT INFO?"))
(setq P (getpoint "\nPOINT INFO?"))
(command "_line" P2 p "")
(setq P (polar P SU 0.3))
(command "_text" P 0  message_setup "")
  ;(alert message)
	)



(defun C:I_DANCE()
(setq P2 (getpoint "\nPOINT INFO?"))
(setq P (getpoint "\nPOINT INFO?"))
(command "_line" P2 p "")
(setq P (polar P SU 0.3))
(command "_text" P 0  message_DANCE "")
  ;(alert message)
	)


(defun C:3D ()
(setq SUFFIX "_3D")


  	(setq old_BLOCCO (car (entsel "\nSeleziona il blocco da cambiare\n ")))
	(setq old_DatiB (entget old_BLOCCO));estrae tutte le informazioni del blocco
	;(setq old_NBLOC "CHAISE");recupera il nome del blocco selezionato
	;(setq New_NBloc "CHAISE_3D")
	(setq ENT1 (ssget "x" (list (cons 0 "INSERT") )));selezione dei blocchi
   	
  ;(setq ENT1 (ssget))
  	;(setq ENT1 (ssget "x" (list (cons 0 "INSERT") (cons 2 old_NBLOC ))));selezione dei blocchi
   	(setq New_NBloc (strcat old_nbloc suffix))
  ;crea il nuovo nome di blocco aggiungendo
  ;il suffisso _3d al vecchio nome 

	(command "insert" new_BLOC nil)
   	(setq N (sslength ENT1));conta le entit
   (setq I 0);index 
   (repeat N
      (setq BL1 (entget (ssname ENT1 I)));primo calcolo
      (setq NWNM (cons 2 new_NBLOC));costruisce primo nuovo nome blocco
      (setq OLD (assoc 2 BL1))
      (setq ODNM (cdr OLD))
      (entmod (subst NWNM OLD BL1))
      (setq I (1+ I))
   )

(setq old_NBLOC "ECOLE_8");recupera il nome del blocco selezionato
	(setq New_NBloc "ECOLE_8_3D")
	(setq ENT1 (ssget))
  	;(setq ENT1 (ssget "x" (list (cons 0 "INSERT") (cons 2 old_NBLOC ))));selezione dei blocchi
   	;(setq New_NBloc (strcat old_nbloc suffix))
  ;crea il nuovo nome di blocco aggiungendo
  ;il suffisso _3d al vecchio nome 

	(command "insert" new_BLOC nil)
   	(setq N (sslength ENT1));conta le entit
   (setq I 0);index 
   (repeat N
      (setq BL1 (entget (ssname ENT1 I)));primo calcolo
      (setq NWNM (cons 2 new_NBLOC));costruisce primo nuovo nome blocco
      (setq OLD (assoc 2 BL1))
      (setq ODNM (cdr OLD))
      (entmod (subst NWNM OLD BL1))
      (setq I (1+ I))
   )

(setq old_NBLOC "TAB10_182");recupera il nome del blocco selezionato
	(setq New_NBloc "TAB10_182_3D")
	(setq ENT1 (ssget ))
  	;(setq ENT1 (ssget "x" Z1 Z2(list (cons 0 "INSERT") (cons 2 old_NBLOC ))));selezione dei blocchi
   	;(setq New_NBloc (strcat old_nbloc suffix))
  ;crea il nuovo nome di blocco aggiungendo
  ;il suffisso _3d al vecchio nome 

	(command "insert" new_BLOC nil)
   	(setq N (sslength ENT1));conta le entit
   (setq I 0);index 
   (repeat N
      (setq BL1 (entget (ssname ENT1 I)));primo calcolo
      (setq NWNM (cons 2 new_NBLOC));costruisce primo nuovo nome blocco
      (setq OLD (assoc 2 BL1))
      (setq ODNM (cdr OLD))
      (entmod (subst NWNM OLD BL1))
      (setq I (1+ I))
   )

  (prin1)
  )